---
title: RTCOutboundRtpStreamStats
slug: Web/API/RTCOutboundRtpStreamStats
tags:
  - API
  - Dictionary
  - Outbound
  - RTCOutboundRtpStreamStats
  - RTCRtpSender
  - RTP
  - Reference
  - Statistics
  - Stats
  - WebRTC
  - WebRTC API
  - stream
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The <code><strong>RTCOutboundRtpStreamStats</strong></code> dictionary is the {{domxref("RTCStats")}}-based object which provides metrics and statistics related to an outbound {{Glossary("RTP")}} stream being sent by an {{domxref("RTCRtpSender")}}.</span></p>

<h2 id="Properties">Properties</h2>

<p><em>The <code>RTCOutboundRtpStreamStats</code> dictionary includes the following properties in addition to those it inherits from {{domxref("RTCSentRtpStreamStats")}}, {{domxref("RTCRtpStreamStats")}}, and {{domxref("RTCStats")}}.</em></p>

<dl>
 <dt>{{domxref("RTCOutboundRtpStreamStats.averageRtcpInterval", "averageRtcpInterval")}}</dt>
 <dd>A floating-point value indicating the average {{Glossary("RTCP")}} interval between two consecutive compound RTCP packets.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.firCount", "firCount")}}</dt>
 <dd>An integer value which indicates the total number of Full Intra Request (FIR) packets which this {{domxref("RTCRtpSender")}} has sent to the remote {{domxref("RTCRtpReceiver")}}. This is an indicator of how often the stream has lagged, requiring frames to be skipped in order to catch up. <em>Valid only for video streams.</em></dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.framesEncoded", "framesEncoded")}}</dt>
 <dd>The number of frames that have been successfully encoded so far for sending on this RTP stream. <em>Only valid for video streams.</em></dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.lastPacketSentTimestamp", "lastPacketSentTimestamp")}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} indicating the time at which the last packet was sent for this SSRC. The {{domxref("RTCStats.timestamp", "timestamp")}} property, on the other hand, indicates the time at which the <code>RTCOutboundRtpStreamStats</code> object was generated.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.nackCount", "nackCount")}}</dt>
 <dd>An integer value indicating the total number of Negative ACKnolwedgement (NACK) packets this <code>RTCRtpSender</code> has received from the remote {{domxref("RTCRtpReceiver")}}.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.perDscpPacketsSent", "perDscpPacketsSent")}}</dt>
 <dd>A record of key-value pairs with strings as the keys mapped to 32-bit integer values, each indicating the total number of packets this <code>RTCRtpSender</code> has transmitted for this source for each Differentiated Services Code Point (DSCP).</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.pliCount", "pliCount")}}</dt>
 <dd>An integer specifying the number of times the remote receiver has notified this <code>RTCRtpSender</code> that some amount of encoded video data for one or more frames has been lost, using Picture Loss Indication (PLI) packets. <em>Only available for video streams.</em></dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.qpSum", "qpSum")}}</dt>
 <dd>A 64-bit value containing the sum of the QP values for every frame encoded by this {{domxref("RTCRtpSender")}}. <em>Valid only for video streams.</em></dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.qualityLimitationDurations", "qualityLimitationDurations")}}</dt>
 <dd>A record mapping each of the quality limitation reasons in the {{domxref("RTCRemoteInboundRtpStreamStats")}} enumeration to a floating-point value indicating the number of seconds the stream has spent with its quality limited for that reason.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.qualityLimitationReason", "qualityLimitationReason")}}</dt>
 <dd>A value from the {{domxref("RTCQualityLimitationReason")}} enumerated type explaining why the resolution and/or frame rate is being limited for this RTP stream. <em>Valid only for video streams</em>.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.remoteId", "remoteId")}}</dt>
 <dd>A string which identifies the {{domxref("RTCRemoteInboundRtpStreamStats")}} object that provides statistics for the remote peer for this same SSRC. This ID is stable across multiple calls to <code>getStats()</code>.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.retransmittedBytesSent", "retransmittedBytesSent")}}</dt>
 <dd>The total number of bytes that have been retransmitted for this source as of the time the statistics were sampled. These retransmitted bytes comprise the packets included in the value returned by {{domxref("RTCInboundRtpStreamStats.retransmittedPacketsSent", "retransmittedPacketsSent")}}.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.retransmittedPacketsSent", "retransmittedPacketsSent")}}</dt>
 <dd>The total number of packets that have needed to be retransmitted for this source as of the time the statistics were sampled. These retransmitted packets are included in the value returned by {{domxref("RTCInboundRtpStreamStats.packetsSent", "packetsSent")}}.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.senderId", "senderId")}}</dt>
 <dd>The {domxref("RTCStats.id", "id")}} of the {{domxref("RTCAudioSenderStats")}} or {{domxref("RTCVideoSenderStats")}} object containing statistics about this stream's {{domxref("RTCRtpSender")}}.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.sliCount", "sliCount")}}</dt>
 <dd>An integer indicating the number of times this sender received a Slice Loss Indication (SLI) frame from the remote peer, indicating that one or more consecutive video macroblocks have been lost or corrupted. Available only for video streams.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.targetBitrate", "targetBitrate")}}</dt>
 <dd>A value indicating the bit rate the <code>RTCRtpSender</code>'s codec is configured to attempt to achieve in its output media.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.totalEncodedBytesTarget", "totalEncodedBytesTarget")}}</dt>
 <dd>A cumulative sum of the <em>target</em> frame sizes (the targeted maximum size of the frame in bytes when the codec is asked to compress it) for all of the frames encoded so far. This will likely differ from the total of the <em>actual</em> frame sizes.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.totalEncodeTime", "totalEncodeTime")}}</dt>
 <dd>A floating-point value indicating the total number of seconds that have been spent encoding the frames encoded so far by this {{domxref("RTCRtpSender")}}.</dd>
 <dt>{{domxref("RTCOutboundRtpStreamStats.trackId", "trackId")}}</dt>
 <dd>The {{domxref("RTCStats.id", "id")}} of the {{domxref("RTCSenderAudioTrackAttachmentStats")}} or {{domxref("RTCSenderVideoTrackAttachmentStats")}} object containing the current track attachment to the {{domxref("RTCRtpSender")}} responsible for this stream.</dd>
</dl>

<h2 id="Examples">Examples</h2>


<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#outboundrtpstats-dict*', 'RTCOutboundRtpStreamStats') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCOutboundRtpStreamStats")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("RTCStats")}}</li>
 <li>{{domxref("RTCStatsReport")}}</li>
</ul>
